/*
 Copyright (C) 1996 Mike White
 Permission is granted to any individual or institution to use, copy, or
 redistribute this software so long as all of the original files are included,
 that it is not sold for profit, and that this copyright notice is retained.

*/
/* MS Windows Setup  and Take-Down functions bracket calls to
 * process_zipfiles().
 * These functions allocate and free the necessary buffers, set and clear
 * any global variables so that  process_zipfiles()  can be called multiple
 * times in the same session of WiZ.
 *
 * Based on Robert Heath's code in a module I no longer remember
 * the name of.
 */

#include <stdio.h>
#include <windows.h>
#include "version.h"
#define UNZIP_INTERNAL
#include "unzip.h"
#include "windll.h"
#include "consts.h"

extern HANDLE hOutBuf;
extern HANDLE hInBuf;
extern HANDLE hZipFN;
extern HANDLE hwildZipFN;
extern HANDLE hFileName;
/*
    ncflag    = write to stdout if true
    ntflag    = test zip file
    nvflag    = verbose listing
    nUflag    = "update" (extract only newer/new files
    nzflag    = display zip file comment
    ndflag    = all args are files/dir to be extracted
    noflag    = overwrite all files
    naflag    = do ASCII-EBCDIC and/or end of line translation
    nZIflag   = get Zip Info if true
    fPrivilege = restore ACL's if 1, use privileges if 2
    lpszZipFN = zip file name
*/
BOOL WINAPI Unz_SetOpts(__G__ C)
__GDEF
LPDCL C;
{
    G.qflag=C->fQuiet;  /* Quiet flag */
    G.pfnames = &fnames[0];       /* assign default file name vector */

    G.jflag = !C->ndflag;
    G.cflag = C->ncflag;
    G.overwrite_all = C->noflag;
    G.tflag = C->ntflag ;
    G.vflag = C->nvflag;
    G.zflag = C->nzflag;
    G.uflag = C->nUflag;
    G.aflag = C->naflag;
    G.uflag = C->ExtractOnlyNewer;
#ifdef WIN32
    G.X_flag = C->fPrivilege;
#endif
    if (C->Overwrite)
        {
        G.overwrite_all = TRUE;
        G.overwrite_none = FALSE;
        }
    else
        {
        G.overwrite_all = FALSE;
        G.overwrite_none = TRUE;
        }
    G.sflag = C->SpaceToUnderscore; /* Translate spaces to underscores? */
    if (C->nZIflag)
      {
      G.zipinfo_mode = TRUE;
      G.hflag = TRUE;
      G.lflag = 10;
      G.qflag = 2;
      }
    else
      {
      G.zipinfo_mode = FALSE;
      }

    G.xfilespecs = 0;

    G.local_hdr_sig[0] = G.central_hdr_sig[0] = G.end_central_sig[0] = '\120';
    G.local_hdr_sig[1] = G.central_hdr_sig[1] = G.end_central_sig[1] = '\0';

    G.cur_zipfile_bufstart = 0L;
    if ((hZipFN = GlobalAlloc(GMEM_MOVEABLE, FILNAMSIZ))== (HGLOBAL)NULL)
        return FALSE;

    G.zipfn = (char far *)GlobalLock(hZipFN);
    lstrcpy(G.zipfn, C->lpszZipFN);

/* G.wildzipfn needs to be initialized so that do_wild does not wind
   up clearing out the zip file name when it returns in process.c
*/
    if ((hwildZipFN = GlobalAlloc(GMEM_MOVEABLE, FILNAMSIZ))== (HGLOBAL)NULL)
        return FALSE;

    G.wildzipfn = GlobalLock(hwildZipFN);
    lstrcpy(G.wildzipfn, C->lpszZipFN);

    return TRUE;    /* set up was OK */
}

void FreeDllMem(__G)
__GDEF
{
    if (G.inbuf) {
        GlobalUnlock(hInBuf);
        G.inbuf = NULL;
    }
    if (hInBuf)
        hInBuf = GlobalFree(hInBuf);

    if (G.outbuf) {
        GlobalUnlock(hOutBuf);
        G.outbuf = NULL;
    }
    if (hOutBuf)
        hOutBuf = GlobalFree(hOutBuf);

    if (G.zipfn) {
        GlobalUnlock(hZipFN);
        G.zipfn = NULL;
    }
    if (hZipFN)
        hZipFN = GlobalFree(hZipFN);

    if (G.wildzipfn) {
        GlobalUnlock(hwildZipFN);
        G.wildzipfn = NULL;
    }
    if (hwildZipFN)
        hwildZipFN = GlobalFree(hwildZipFN);

    if (G.filename) {
        GlobalUnlock(hFileName);
        G.filename = NULL;
    }
    if (hFileName)
        hFileName = GlobalFree(hFileName);
G.zipinfo_mode = FALSE;
}

