#ifndef __windll_h   /* prevent multiple inclusions */
#define __windll_h

#include <windows.h>
#include <assert.h>    /* required for all Windows applications */
#include <setjmp.h>
#include <commdlg.h>
#include <dlgs.h>
#define UNZIP_INTERNAL
#include "unzip.h"
#include "structs.h"

#ifndef MSWIN
#  define MSWIN
#endif

/* Allow compilation under Borland C++ also */
#ifndef __based
#define __based(A)
#endif

/* Porting definations between Win 3.1x and Win32 */
#ifdef WIN32
#  define far
#  define _far
#  define __far
#  define near
#  define _near
#  define __near
#endif

#ifndef PATH_MAX
#define PATH_MAX  128             /* max total file or directory name path */
#endif

/* These two are dependent on the zip directory listing format string.
 * They help find the filename in the listbox entry.
 */
#define SHORT_FORM_FNAME_INX     27
#define LONG_FORM_FNAME_INX      58

#ifndef NDEBUG
#define WinAssert(exp) \
        {\
        if (!(exp))\
            {\
            char szBuffer[40];\
            sprintf(szBuffer, "File %s, Line %d",\
                    __FILE__, __LINE__) ;\
            if (IDABORT == MessageBox((HWND)NULL, szBuffer,\
                "Assertion Error",\
                MB_ABORTRETRYIGNORE|MB_ICONSTOP))\
                    FatalExit(-1);\
            }\
        }

#else

#define WinAssert(exp)

#endif

#define IDM_REPLACE_NO     100
#define IDM_REPLACE_TEXT   101
#define IDM_REPLACE_YES    102
#define IDM_REPLACE_ALL    103
#define IDM_REPLACE_NONE   104
#define IDM_REPLACE_RENAME 105
#define IDM_REPLACE_HELP   106

extern jmp_buf dll_error_return;
extern HWND hWndList;       /* listbox handle */
extern HWND hWndMain;       /* the main window handle. */
extern HANDLE hInst;        /* current instance */
extern HANDLE hHourGlass;   /* handle to hourglass cursor */
extern HANDLE hSaveCursor;  /* current cursor handle */

extern char szTargetDirName[];

extern LPDCL lpDCL;
extern LPUSERFUNCTIONS lpUserFunctions;

BOOL WINAPI Unz_SetOpts(__GPRO__ LPDCL);
BOOL WINAPI Unz_Init(__GPRO__ USERFUNCTIONS far *);
int WINAPI Unz_Unzip(__GPRO__ int, char **);
void FreeDllMem(__GPRO);
int win_fprintf(FILE *file, unsigned int, char far *);
extern WINAPI windll_unzip(int, char **, DCL far *, USERFUNCTIONS far *);

#endif /* __windll_h */
